import LichessPgnViewer from './lichess-pgn-viewer.js';

LichessPgnViewer(document.querySelector('div'), {
  pgn: `[Event "FIDE World Championship 2024"]
[Site "Singapore, Singapore"]
[Date "2024.11.30"]
[Round "5"]
[White "Gukesh D"]
[Black "Ding, Liren"]
[Result "1/2-1/2"]
[WhiteElo "2783"]
[WhiteTitle "GM"]
[WhiteFideId "46616543"]
[BlackElo "2728"]
[BlackTitle "GM"]
[BlackFideId "8603677"]
[Annotator "https://lichess.org/@/Rikikits"]
[Variant "Standard"]
[ECO "C01"]
[Opening "French Defense: Exchange Variation"]
[StudyName "World Championship 2024: Annotated Games"]
[ChapterName "Gukesh D - Ding, Liren (Lagarde)"]
[Source "https://lichess.org/study/LF4x850G/IAPVNb4a"]
[Orientation "white"]

1. e4 e6 { Ding decides to play the french again. I personally cannot say that being in a french mood is a bad thing but it would not be a surprise if Richard Rapport is behind this choice. Ding's second is definitely an expert on this opening. } 2. d4 d5 3. exd5 { Gukesh decides to vary from round 1 and play a much more solid line, the exchange french. This line has become fashion in top level tournaments these last few months. White will try to get a slight advantage from their extra tempo. } (3. Nc3 { , a much more aggressive line, had been played in round 1 which led to a double edge position and the defeat of Gukesh. }) 3... exd5 4. Nf3 Nf6 (4... Nc6!? { is another agressive way to play in order to immediately stop the symetrical position. } 5. Nc3 Bg4!?) 5. Bd3 c5!? { Ding decides to unbalance the position and not to play the symmetrical continuation with 5...Bd6. That last move can give an isolated pawn structure which means Ding was ready to play a dynamic game. } (5... Bd6 { is the other
way to play. }) 6. c3!? { Ding decides to unbalance the position and not to play the symmetrical continuation with 5...Bd6. That last move can give an isolated pawn structure which means Ding was ready to play a dynamic game. } (6. dxc5 Bxc5 { leads to a good isolated pawn position for Black. } 7. O-O O-O 8. Bg5 h6 9. Bh4 g5! 10. Bg3 Ne4 { Black get the initiative. }) (6. O-O { is the main line } 6... c4 7. Re1+ Be7 8. Bf1 O-O 9. b3 cxb3 10. axb3 Nc6 { with a certain equality. The move of the game seems to be more precise to keep the bishop on the b1-h7 diagonal. }) 6... c4 { Ding immediately chooses to fix the structure. } (6... Bd6 { or 6...Nc6 are also possible to keep the pressure in the center. }) 7. Bc2 Bd6 { so far both players played very fast meaning they were both in known fields. } 8. Qe2+ (8. O-O O-O 9. Ne5!? { is another interesting dynamic
way to play. } 9... Qc7 10. f4 Nc6 11. Qf3 Ne7 12. g4!? $13 { objectively the position is fine for black but it can be scary somehow for them thanks to this strong e5-knight. For example grabbing the pawn after: } 12... Bxe5? (12... b5 $13) 13. fxe5 Nxg4 14. h3 Nh6 15. Bxh6 gxh6 16. Na3 $18 { White will have a winning attack. }) 8... Qe7 (8... Be6?! { could be tempting in order to keep the queens
on the board but after } 9. Ng5 Qe7 (9... O-O 10. Nxe6 fxe6 11. Qxe6+ Kh8 12. O-O $18) 10. Nxe6 fxe6 11. f4! { White has a considerable positional advantage thanks to the weak e6-pawn and the bishop pair. }) 9. Qxe7+ Kxe7 { and after that move, Gukesh will enter a deep thought. So far Ding played his moves very fast so it seems that Gukesh was the first one out of theory. In the press conference after the game, Gukesh said that he probably saw this before but couldn't remember the line during the game. } 10. O-O (10. b3 { is often a normal way to play against this structure, in order to weaken the c4-pawn. } 10... Be6 11. bxc4 dxc4 12. O-O Nc6 13. a4 $13 { White has weaken the c4-pawn but had to give the d5-square as a concession. }) 10... Re8 { and after that move, Gukesh will enter a deep thought. So far Ding played his moves very fast so it seems that Gukesh was the first one out of theory. In the press conference after the game, Gukesh said that he probably saw this before but couldn't remember the line during the game. } 11. Re1+ Kf8 12. Rxe8+ Kxe8 13. Bg5 Nbd7 14. Nbd2 { And is the first long thought for Ding. Only one game was played in this position in 2018 (Damjanovic,V - Kramer, J). If White managed to put a knight in e5 by playing Re1 followed by Ne5, they could claim an advantage. Obviously, Black will not sit and do nothing about that. } (14. Nh4!? { could have been an interesting way to put pressure over Black position. White knight is going to jump to this annoying f5-square. } 14... g6! 15. g3 { to replace the knight to e3 via g2. } 15... Ng8!? { in order to move the d7-knight. } { [%cal Gh4g2,Gg2e3] } 16. Ng2 Nf8) 14... h6 15. Bh4 Nh5! { Ding aims to find the better square for his knight -f4 square. } 16. Re1+ (16. a4 { here is something to be considered as it stops any counterplay on the queenside. } 16... g5 17. Bg3 Nxg3 18. hxg3 Nf6 19. Nf1) 16... Kf8 17. g4!? { I must admit I was very surprised as many other players by this move. I thought that game was going to end with another insipid draw but I changed my mind after that move. It may not be the best move objectively but Gukesh tries to provoke Ding and I think that is a good psychological choice. He is forcing him to calculate many different lines from now. } (17. Ne5? { does not work now that the knight is not on f6, Black can simply play } 17... Nxe5 18. dxe5 Bc5 $17) (17. Nf1 { was the logical move, in order to go to e3. } { [%cal Gf1e3] }) 17... Nf4 18. Bg3 { White wants to take advantage of the pin. They also want to play Ne5. } { [%cal Rg3d6] } 18... Nb6 { many other continuations were possible but this is probably the simplest. } (18... Nh3+ 19. Kf1!? (19. Kg2 Nf4+ { could implicitly offer a draw }) 19... Bxg3 20. hxg3 Nf6 21. Ne5 Nxg4 22. Nxg4 Bxg4 23. f3 Be6 24. f4 Bg4 25. Kg2 g5 26. f5 { from a human view it looks really hard to play with back here, even if computer is holding. }) (18... g5!? { an agressive way to play! } 19. h4!? (19. Nf1 Nf6 20. Ne3 Bxg4 21. Nxg4 Nxg4 22. h4 Kg7 $13) 19... Nf6! { and here is the mess! } 20. hxg5 hxg5 21. Nxg5 Bxg4 22. Nf1 { with a very complex position and a nice ballet of minor pieces! }) (18... b5!? 19. Nf1 Nb6 20. Ne3 a5 21. h4 { would lead to a double-edged position, with both camps trying to get an advantage on each side. }) 19. g5 { Gukesh sacrificed his kingside structure to get an active and dynamic play. That is a risky choice as if he does not manage to compensate dynamically, he will remain with a small long-term positional disadvantage. } (19. Ne5 { has to be checked } 19... Bxe5 20. Rxe5 (20. dxe5 Nd3 21. Bxd3 cxd3 22. h3 Nc4 $15) 20... Nd3 21. Bxd3 cxd3 22. f3 Nc4 23. Nxc4 dxc4 24. Kf2 b6 $15) 19... hxg5 (19... Nh3+ { seems to win a pawn but } 20. Kf1 Bxg3 (20... Nf4 21. gxh6 $16) 21. gxh6! { an important intermediate move. } 21... gxh6 (21... Bf4 22. h7!) 22. hxg3 $18) 20. Nxg5 { Gukesh sacrificed his kingside structure to get an active and dynamic play. That is a risky choice as if he does not manage to compensate dynamically, he will remain with a small long-term positional disadvantage. } 20... Bd7 21. Ngf3 { aiming to jump on e5. } { [%cal Gf3e5] } (21. Nf1 { was also possible } 21... Re8 22. Ne3) 21... Re8 (21... Rd8!? { in order to keep the pieces } 22. Nf1 (22. Ne5 Bxe5 23. dxe5 Nd3 $15) 22... Na4 $13) 22. Ne5 (22. Nf1 { was more logical. }) 22... Bxe5 23. dxe5? { a very surprising mistake played in few seconds. What surprised me even more is that Gukesh played his last 4 moves in less than 5 minutes althought nothing was forced. Gukesh strategy to put pressure on Ding on position and time backfired him. } (23. Rxe5 { was necessary } 23... Ne2+!? (23... Rxe5 24. dxe5 Ba4 25. Bxa4 Ne2+ 26. Kf1 Nxg3+ 27. fxg3 Nxa4 28. Kf2 Nxb2 29. Ke3 $13) 24. Kf1 Nc1 25. Rxe8+ Kxe8 26. Bf4 Nxa2 27. Ke1 Nc1 28. Nxc4!) 23... Nd3! { played very fast by Ding as well. After that move, Ding is getting a clear advantage. Gukesh went for a deep think after that move, probably realizing he underestimated the potential of black position. } 24. Bxd3 (24. Rb1 Nxe5 $17) 24... cxd3 { the d3-pawn will be a real spine in white's position. } 25. f3 (25. b3 { to avoid
Nc4 weakens the c3-pawn } 25... Rc8 26. Rc1 (26. Nb1 Bf5 $17) 26... d4! 27. c4 Nd5! $19 { followed by Nc3 } { [%cal Gd5c3] }) 25... Nc4 (25... Na4 { Nc4 is more of a simple move while this one has a bit more spice } 26. Rb1 (26. Kf2 { this was the move Ding was worried about but after } 26... Nxb2 27. Rb1 Nc4 28. Nxc4 dxc4 29. Rxb7 Bc6 30. Rb2 Ke7 $17 { is great for black }) 26... f6 $17 { GM Aronian prefered this continuation during the broadcast }) 26. Nxc4 dxc4 27. Re4 Bc6? { that move only helps to organize the defense. } (27... Be6! { was the right way to play. in order to free the c-file and to protect the important c4 pawn. } 28. Rd4 Rc8 29. Kf2 (29. Bf2 Kg8! 30. Be3 Kh7 { the black king will put pressure on the kingside while the black room will handle the queenside. From a human view, the position is really hard to defend for white. }) 29... Rc5! { the rook will now put pressure on the queenside. The position may be already winning for black. }) 28. Rd4 (28. Rxc4?? { would lose after } 28... Rd8! { followed by d2 } { [%cal Gd3d2] }) 28... Bxf3 29. Kf2 Bc6? { a disappointing move. Ding missed the right spot for the bishop in the previous move but here he does not even try to put pressure on Gukesh in this no-risk position. } (29... Bh5! { was the only way to keep putting pressure. } 30. Ke3 (30. Rxc4?? d2 { followed by promotion. }) 30... b5 31. b3 Rc8 $15 { although the position is not winning anymore, Black is still putting pressure thanks to the d3-pawn. }) 30. Rxc4 Rd8 31. Rd4 Rxd4 32. cxd4 { this bishop endgame is a dead draw } 32... Bd5 33. b3 Ke7 34. Ke3 Ke6 35. Kxd3 g6 36. Kc3 a6 37. Kd3 Kf5 38. Ke3 Ke6 39. Kd3 Kf5 40. Ke3 Ke6 { A frustrating end. Ding played a great game and when he could definitely get a clear advantage (almost winning) he decided to simplify the position to get a draw. It is not so easy to get a big advantage in such a match, let's hope that he will not regret his decision. } 1/2-1/2
`
});
